# Source Generated with Decompyle++
# File: in.pyc (Python 1.5)

import Bladex
import CharStats

class EnemyLevelControl:
    '''Enemy Level Control Class \tUsed for adjusting enemy levels, based on how well the player is doing \tagainst designer expectations for this map.  Normally to be instantiated \tduring map creation, all further enemies created can have their level \tadjusted according to how well the player was doing in the moment of the \tcontrol creation.  Syntax for creation is: \t\tlvl_control= LevelFuncs.EnemyLevelControl (expected_player_lvl_min, expected_player_lvl_max) \tthen later replace calls like... \t\tenemy.Level= 9 \twith \t\tenemy.Level= lvl_control.GiveLevel (8, 10) \t'''
    progression_factor = 0.0
    
    def __init__(self, expected_player_lvl_min, expected_player_lvl_max):
        player = Bladex.GetEntity('Player1')
        
        try:
            LevelLimit = 1.0 * CharStats.GetCharExperienceCost(player.CharType, player.Level)
            adjusted_player_lvl = player.Level + player.PartialLevel / LevelLimit
            adjusted_player_lvl = max(adjusted_player_lvl, 1.0 * expected_player_lvl_min)
            adjusted_player_lvl = min(adjusted_player_lvl, 1.0 * expected_player_lvl_max)
            self.progression_factor = (adjusted_player_lvl - expected_player_lvl_min) / (expected_player_lvl_max - expected_player_lvl_min)
        except:
            print '!!!Error!!! initializing EnemyLevelControl.  Probable cause: Player1 not accessible'


    
    def GiveLevel(self, enemy_lvl_min, enemy_lvl_max):
        return round((enemy_lvl_max - enemy_lvl_min) * self.progression_factor + enemy_lvl_min)


